VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "CTooltip"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Attribute VB_Ext_KEY = "SavedWithClassBuilder6" ,"Yes"
Attribute VB_Ext_KEY = "Top_Level" ,"Yes"
Option Explicit

Private Declare Sub InitCommonControls Lib "comctl32.dll" ()

' Windows API Functions
Private Declare Function CreateWindowEx Lib "user32" Alias "CreateWindowExA" (ByVal dwExStyle As Long, ByVal lpClassName As String, ByVal lpWindowName As String, ByVal dwStyle As Long, ByVal X As Long, ByVal Y As Long, ByVal nWidth As Long, ByVal nHeight As Long, ByVal hWndParent As Long, ByVal hMenu As Long, ByVal hInstance As Long, lpParam As Any) As Long
Private Declare Function SendMessage Lib "user32" Alias "SendMessageA" (ByVal hWnd As Long, ByVal wMsg As Long, ByVal wParam As Long, lParam As Any) As Long
Private Declare Function SendMessageLong Lib "user32" Alias "SendMessageA" (ByVal hWnd As Long, ByVal wMsg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
Private Declare Function DestroyWindow Lib "user32" (ByVal hWnd As Long) As Long
Private Declare Function CreateFont Lib "gdi32.dll" Alias "CreateFontA" ( _
    ByVal H As Long, _
    ByVal W As Long, _
    ByVal E As Long, _
    ByVal O As Long, _
    ByVal W As Long, _
    ByVal I As Long, _
    ByVal u As Long, _
    ByVal S As Long, _
    ByVal C As Long, _
    ByVal OP As Long, _
    ByVal CP As Long, _
    ByVal Q As Long, _
    ByVal PAF As Long, _
    ByVal F As String) As Long
Private Declare Function GetDC Lib "user32.dll" ( _
    ByVal hWnd As Long) As Long
Private Declare Function GetDeviceCaps Lib "gdi32.dll" ( _
    ByVal hdc As Long, _
    ByVal nIndex As Long) As Long
Private Declare Function MulDiv Lib "kernel32.dll" ( _
    ByVal nNumber As Long, _
    ByVal nNumerator As Long, _
    ByVal nDenominator As Long) As Long

' Windows API Constants
Private Const WM_USER = &H400
Private Const CW_USEDEFAULT = &H80000000
Private Const LOGPIXELSY As Long = 90
Private Const WM_SETFONT As Long = &H30
Private Const WM_GETFONT As Long = &H31
Private Const TTF_ABSOLUTE As Long = &H80
Private Const TTF_TRACK As Long = &H20
Private Const TTM_TRACKPOSITION As Long = (WM_USER + 18)
Private Const TTM_TRACKACTIVATE As Long = (WM_USER + 17)

' Windows API Types
Private Type RECT
    Left As Long
    Top As Long
    Right As Long
    Bottom As Long
End Type

' Tooltip Window Constants
Private Const TTS_NOPREFIX = &H2
Private Const TTF_TRANSPARENT = &H100
Private Const TTF_CENTERTIP = &H2
Private Const TTM_ADDTOOLA = (WM_USER + 4)
Private Const TTM_ACTIVATE = WM_USER + 1
Private Const TTM_UPDATETIPTEXTA = (WM_USER + 12)
Private Const TTM_SETMAXTIPWIDTH = (WM_USER + 24)
Private Const TTM_SETTIPBKCOLOR = (WM_USER + 19)
Private Const TTM_SETTIPTEXTCOLOR = (WM_USER + 20)
Private Const TTM_SETTITLE = (WM_USER + 32)
Private Const TTS_BALLOON = &H40
Private Const TTS_ALWAYSTIP = &H1
Private Const TTF_SUBCLASS = &H10
Private Const TTF_IDISHWND = &H1
Private Const TTM_SETDELAYTIME = (WM_USER + 3)
Private Const TTDT_AUTOPOP = 2
Private Const TTDT_INITIAL = 3

Private Const TOOLTIPS_CLASSA = "tooltips_class32"

' Tooltip Window Types
Private Type TOOLINFO
    lSize As Long
    lFlags As Long
    hWnd As Long
    lId As Long
    lpRect As RECT
    hInstance As Long
    lpStr As String
    lParam As Long
End Type

Public Enum ttIconType
    TTNoIcon = 0
    TTIconInfo = 1
    TTIconWarning = 2
    TTIconError = 3
End Enum

Public Enum ttStyleEnum
    TTStandard
    TTBalloon
End Enum

' local variables to hold property values
Private mvarBackColor As Long
Private mvarTitle As String
Private mvarForeColor As Long
Private mvarIcon As ttIconType
Private mvarCentered As Boolean
Private mvarStyle As ttStyleEnum
Private mvarTipText As String
Private mvarVisibleTime As Long
Private mvarDelayTime As Long
Private mvarTopLeftCorner As Long
Private mvarMaxTipWidth As Long
Private mvarToolTipFont As StdFont
Private m_lTTHwnd As Long     ' << hWnd of the tooltip

' private data
Private m_lParentHwnd As Long ' << hWnd of the window the tooltip attached to
Private ti As TOOLINFO

Public Property Get TTHwnd() As Long
    ' read-only property assigned in "Create" method
    TTHwnd = m_lTTHwnd
End Property

Public Property Set ToolTipFont(ByVal vData As StdFont)
    Set mvarToolTipFont = vData
End Property

Public Property Get ToolTipFont() As StdFont
    Set ToolTipFont = mvarToolTipFont
End Property

Public Property Let MaxTipWidth(ByVal vData As Long)
    mvarMaxTipWidth = vData
End Property

Public Property Get MaxTipWidth() As Long
    MaxTipWidth = mvarMaxTipWidth
End Property

Public Property Let TopLeftCorner(ByVal vData As Long)
    mvarTopLeftCorner = vData
End Property

Public Property Get TopLeftCorner() As Long
    TopLeftCorner = mvarTopLeftCorner
End Property

Public Property Let Style(ByVal vData As ttStyleEnum)
    mvarStyle = vData
End Property

Public Property Get Style() As ttStyleEnum
    Style = mvarStyle
End Property

Public Property Let Centered(ByVal vData As Boolean)
    mvarCentered = vData
End Property

Public Property Get Centered() As Boolean
    Centered = mvarCentered
End Property

Public Function Create(ByVal ParentHwnd As Long) As Boolean
    Dim lWinStyle As Long
    Dim hFont As Long
    Dim lHeight As Long
    Dim lItalic As Long
    Dim lBold As Long
    Dim lUnderline As Long
    Dim lStrikethrough As Long
    Dim lDefaultLocaleID As Long
    Dim lRet As Long
    Dim strCodePage As String * 6
    Dim lCodePage As Long
    
    If m_lTTHwnd <> 0 Then DestroyWindow m_lTTHwnd
   
    m_lParentHwnd = ParentHwnd
   
    lWinStyle = TTS_ALWAYSTIP Or TTS_NOPREFIX
   
    ' create baloon style if desired
    If mvarStyle = TTBalloon Then lWinStyle = lWinStyle Or TTS_BALLOON
    
    m_lTTHwnd = CreateWindowEx(0&, _
        TOOLTIPS_CLASSA, _
        vbNullString, _
        lWinStyle, _
        CW_USEDEFAULT, _
        CW_USEDEFAULT, _
        CW_USEDEFAULT, _
        CW_USEDEFAULT, _
        0&, _
        0&, _
        App.hInstance, _
        0&)
               
    ' now set our tooltip info structure:
    With ti
        ' if we want it centered, then set that flag
        .lFlags = TTF_SUBCLASS Or TTF_IDISHWND Or TTF_ABSOLUTE Or TTF_TRACK
        If mvarCentered Then .lFlags = .lFlags Or TTF_CENTERTIP
        ' set the hWnd prop to our parent control's hwnd
        .hWnd = m_lParentHwnd
        .lId = m_lParentHwnd '0
        .hInstance = App.hInstance
        '.lpstr =
        '.lpRect =
        .lSize = Len(ti)
    End With
   
    ' add the tooltip structure
    SendMessage m_lTTHwnd, TTM_ADDTOOLA, 0&, ti
    
    ' set the desired font for tooltip:
    
'    If Not mvarToolTipFont Is Nothing Then
'        lHeight = -MulDiv(mvarToolTipFont.Size, GetDeviceCaps(GetDC(m_lTTHwnd), LOGPIXELSY), 72)
'        lItalic = IIf(mvarToolTipFont.Italic, 1&, 0&)
'        lBold = IIf(mvarToolTipFont.Bold, 700&, 400&)
'        lUnderline = IIf(mvarToolTipFont.Underline, 1&, 0&)
'        lStrikethrough = IIf(mvarToolTipFont.Strikethrough, 1&, 0&)
'        hFont = CreateFont(lHeight, 0&, 0&, 0&, lBold, lItalic, lUnderline, lStrikethrough, _
'                           0&, 0&, 0&, 0&, 0&, mvarToolTipFont.Name)
'        lRet = SendMessageLong(m_lTTHwnd, WM_SETFONT, hFont, 1&)
'    End If
    
    ' it's too complex solution - we can simply use WM_GETFONT message to retrieve font of the parent window:
    hFont = SendMessageLong(m_lParentHwnd, WM_GETFONT, 0, 0)
    lRet = SendMessageLong(m_lTTHwnd, WM_SETFONT, hFont, 1&)
    ' (in such case property TT.ToolTipFont has no meaning anymore)
    
    ' if we want a title or we want an icon
    If mvarTitle <> vbNullString Or mvarIcon <> TTNoIcon Then
        SendMessage m_lTTHwnd, TTM_SETTITLE, CLng(mvarIcon), ByVal mvarTitle
    End If

    If mvarForeColor <> Empty Then SendMessage m_lTTHwnd, TTM_SETTIPTEXTCOLOR, mvarForeColor, 0&
    If mvarBackColor <> Empty Then SendMessage m_lTTHwnd, TTM_SETTIPBKCOLOR, mvarBackColor, 0&
   
    SendMessageLong m_lTTHwnd, TTM_SETDELAYTIME, TTDT_AUTOPOP, mvarVisibleTime
    SendMessageLong m_lTTHwnd, TTM_SETDELAYTIME, TTDT_INITIAL, mvarDelayTime
    
    SendMessageLong m_lTTHwnd, TTM_SETMAXTIPWIDTH, 0, mvarMaxTipWidth
    
    ' we make them trackable:
    SendMessageLong m_lTTHwnd, TTM_TRACKPOSITION, 0, mvarTopLeftCorner
    SendMessage m_lTTHwnd, TTM_TRACKACTIVATE, 1, ti
    
End Function

Public Property Let Icon(ByVal vData As ttIconType)
    mvarIcon = vData
    If m_lTTHwnd <> 0 And mvarTitle <> Empty And mvarIcon <> TTNoIcon Then
        SendMessage m_lTTHwnd, TTM_SETTITLE, CLng(mvarIcon), ByVal mvarTitle
    End If
End Property

Public Property Get Icon() As ttIconType
    Icon = mvarIcon
End Property

Public Property Let ForeColor(ByVal vData As Long)
    mvarForeColor = vData
    If m_lTTHwnd <> 0 Then SendMessage m_lTTHwnd, TTM_SETTIPTEXTCOLOR, mvarForeColor, 0&
End Property

Public Property Get ForeColor() As Long
    ForeColor = mvarForeColor
End Property

Public Property Let Title(ByVal vData As String)
    mvarTitle = vData
    If m_lTTHwnd <> 0 And mvarTitle <> Empty And mvarIcon <> TTNoIcon Then
        SendMessage m_lTTHwnd, TTM_SETTITLE, CLng(mvarIcon), ByVal mvarTitle
    End If
End Property

Public Property Get Title() As String
    Title = ti.lpStr
End Property

Public Property Let BackColor(ByVal vData As Long)
    mvarBackColor = vData
    If m_lTTHwnd <> 0 Then SendMessage m_lTTHwnd, TTM_SETTIPBKCOLOR, mvarBackColor, 0&
End Property

Public Property Get BackColor() As Long
    BackColor = mvarBackColor
End Property

Public Property Let TipText(ByVal vData As String)
    mvarTipText = vData
    ti.lpStr = vData
    If m_lTTHwnd <> 0 Then SendMessage m_lTTHwnd, TTM_UPDATETIPTEXTA, 0&, ti
End Property

Public Property Get TipText() As String
    TipText = mvarTipText
End Property

Private Sub Class_Initialize()
    InitCommonControls
    mvarDelayTime = 200
    mvarVisibleTime = 5000
End Sub

Private Sub Class_Terminate()
    Destroy
End Sub

Public Sub Destroy()
    If m_lTTHwnd <> 0 Then
        DestroyWindow m_lTTHwnd
        m_lTTHwnd = 0
    End If
End Sub

Public Property Get VisibleTime() As Long
    VisibleTime = mvarVisibleTime
End Property

Public Property Let VisibleTime(ByVal lData As Long)
    mvarVisibleTime = lData
End Property

Public Property Get DelayTime() As Long
    DelayTime = mvarDelayTime
End Property

Public Property Let DelayTime(ByVal lData As Long)
    mvarDelayTime = lData
End Property


