Attribute VB_Name = "SubClassForm"
Option Explicit

Private Type RECT
    Left As Long
    Top As Long
    Right As Long
    Bottom As Long
End Type
Private Type POINTAPI
    X As Long
    Y As Long
End Type
Private Declare Function PtInRect Lib "user32.dll" ( _
    ByRef lpRect As RECT, _
    ByVal X As Long, _
    ByVal Y As Long) As Long
Private Declare Function GetCursorPos Lib "user32" ( _
    lpPoint As POINTAPI) As Long
Private Declare Function GetWindowRect Lib "user32" ( _
    ByVal hWnd As Long, lpRect As RECT) As Long

Public Declare Function SetWindowLong Lib "user32" Alias _
    "SetWindowLongA" (ByVal hWnd As Long, ByVal nIndex As Long, _
    ByVal dwNewLong As Long) As Long
Private Declare Function CallWindowProc Lib "user32" Alias _
    "CallWindowProcA" (ByVal lpPrevWndFunc As Long, _
    ByVal hWnd As Long, ByVal Msg As Long, ByVal wParam As Long, _
    ByVal lParam As Long) As Long
Public Const GWL_WNDPROC = (-4)

'Public Const WM_LBUTTONDBLCLK = &H203
'Public Const WM_LBUTTONDOWN = &H201
'Public Const WM_LBUTTONUP = &H202
'Public Const WM_RBUTTONDBLCLK = &H206
'Public Const WM_RBUTTONDOWN = &H204
'Public Const WM_RBUTTONUP = &H205
'Public Const WM_PARENTNOTIFY = &H210
'Public Const WM_MOUSEACTIVATE As Long = &H21
Private Const WM_NCACTIVATE As Long = &H86
Private Const WM_MOUSEMOVE As Long = &H200
Private Const WM_NCHITTEST As Long = &H84

Public TT As CTooltip

Public mhWndSubClassed As Long
Public mWndProcNext As Long

Public Function WindowProc(ByVal hWnd As Long, ByVal uMsg As Long, _
                           ByVal wParam As Long, ByVal lParam As Long) As Long
    Dim pt As POINTAPI, ttRect As RECT
    
    If uMsg = WM_NCACTIVATE Then
        ' among other reasons, this message could appear from a mouse click on the tooltip rectangle
        If TT.TTHwnd <> 0 Then
            GetWindowRect TT.TTHwnd, ttRect
            GetCursorPos pt
            If PtInRect(ttRect, pt.X, pt.Y) <> 0 Then  ' << a bit shorter than using TTM_HITTESTA and TTHITTESTINFO
                TT.Destroy
                Debug.Print "Tooltip destroyed FORCEDLY", Now
                Exit Function  ' << we need to supress this message - otherwise tooltip's
                               '    parent window (Form1) will remain inactive
            End If
        End If
    ElseIf uMsg = WM_NCHITTEST Or uMsg = WM_MOUSEMOVE Then
        ' the mouse is moving outside the tooltip rectangle:
        If TT.TTHwnd <> 0 Then
            TT.Destroy
            Debug.Print "Tooltip destroyed FORCEDLY", Now
        End If
    End If
    
    WindowProc = CallWindowProc(mWndProcNext, hWnd, uMsg, wParam, ByVal lParam)
    
End Function
